<?php
namespace WebService\Controller;

use Cake\Event\Event;
use Cake\Routing\Router;
use WebService\Controller\AppController;

/**
 * Occurrences Controller
 *
 * @property \WebService\Model\Table\OccurrencesTable $Occurrences
 *
 * @method \WebService\Model\Entity\Occurrence[]|\Cake\Datasource\ResultSetInterface paginate($object = null, array $settings = [])
 */
class OccurrencesController extends AppController
{
    private $dir;

    public function initialize()
    {
        parent::initialize(); // TODO: Change the autogenerated stub
        $this->dir = Router::url('/img/occurrences/', true);
    }

    /**
     * Index method
     *
     * @return \Cake\Http\Response|void
     */
    public function index()
    {
        $occurrences = $this->Occurrences->find('all', [
            'contain' => ['Users', 'Sectors', 'Status', 'Categories']
        ])
          ->orderDesc('Occurrences.created');

        $this->paginate();

        foreach ($occurrences as $occurrence) {
            $occurrence->created = $occurrence->created->diffForHumans();
            $occurrence->modified = $occurrence->modified->diffForHumans();
            $occurrence->image = $this->dir . $occurrence->image;

            if ($occurrence->status_id == SENT) {
                $occurrence->status->status_progress = 0;
            } else if ($occurrence->status_id == RECEIVED) {
                $occurrence->status->status_progress = 1;

            }else if ($occurrence->status_id == IN_PROGRESS) {
                $occurrence->status->status_progress = 2;

            } else if ($occurrence->status_id == FINISHED) {
                $occurrence->status->status_progress = 3;

            } else if ($occurrence->status_id == DENIED) {
                $occurrence->status->status_progress = 4;

            }

            $email_hash = md5(strtolower(trim($occurrence->user->email)));

            $occurrence->user->profile_img = "https://www.gravatar.com/avatar/" . $email_hash . "?s=400";
        }

        $this->set([
            'auth' => $this->request->getParam('auth'),
            'error' => false,
                'occurrences' => $occurrences,
                '_serialize' => ['occurrences', 'error', 'auth']
            ]);
    }

    /**
     * View method
     *
     * @param string|null $id Occurrence id.
     * @return \Cake\Http\Response|void
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function view()
    {
        $occurrence = $this->Occurrences->get($this->request->getQuery('id'), [
            'contain' => ['Users', 'Sectors', 'Status', 'Categories']
        ]);

        $occurrence->image = $this->dir . $occurrence->image;

        $this->set([
            'occurrence' => $occurrence,
            '_serialize' => ['occurrence']
        ]);
    }

    /**
     * Add method
     *
     * @return \Cake\Http\Response|null Redirects on successful add, renders view otherwise.
     */
    public function add()
    {
        if ($this->request->is('post')) {

            $occurrence = $this->Occurrences->getRecords($this->request->getData());
            $occurrence->user_id = $this->Auth->user('id');
            $occurrence->status_id = SENT;

            if ($this->Occurrences->save($occurrence)) {
                $message = __d('web_service', 'The occurrence has been saved.');
                $error = false;
            } else {
              $message = __d('web_service', 'The occurrence could not be saved. Please, try again.');
              $error = true;
            }

            $this->set([
              'occurrence' => $occurrence,
                'message' => $message,
                'error' => $error,
                '_serialize' => ['occurrence', 'error', 'message']
            ]);
        } else {
            $sectors = $this->Occurrences->Sectors->find('list');
            $categories = $this->Occurrences->Categories->find('list');

            $this->set([
                'sectors' => $sectors,
                'categories' => $categories,
                '_serialize' => ['sectors', 'categories']
            ]);
        }
    }
}